/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.17 Revision 1.112
1# Copyright 2007-2008 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.17 2008/11/21 17:06:03 jmbsvicetto Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.112 2012/01/17 11:20:03 johu Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 monolithic ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: This eclass uses the SLOT dependencies from EAPI="1" or compatible, 13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed
14# and use deps from EAPI="2", hence you must define EAPI="2" in the ebuild, 14# over time as new EAPI versions are approved.
15# before inheriting any eclasses.
16 15
17inherit base cmake-utils eutils kde4-functions multilib 16# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
17# @DESCRIPTION:
18# If set to "none", do nothing.
19# For any other value, add selinux to IUSE, and depending on that useflag
20# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
21: ${KDE_SELINUX_MODULE:=none}
18 22
19case "${EAPI}" in 23# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
20 2) 24# @DESCRIPTION:
21 EXPORT_FUNCTIONS pkg_setup src_unpack src_configure src_compile src_test src_install pkg_postinst pkg_postrm 25# For proper description see virtualx.eclass manpage.
22 ;; 26# Here we redefine default value to be manual, if your package needs virtualx
23 *) 27# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
24 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_postinst pkg_postrm 28: ${VIRTUALX_REQUIRED:=manual}
25 ;;
26esac
27 29
28# Set the qt dependencies 30inherit kde4-functions toolchain-funcs fdo-mime gnome2-utils base virtualx versionator eutils
29kde4-base_set_qt_dependencies() {
30 local qt qtcore qtgui qt3support qtdepend qtopengldepend
31 31
32 # use dependencies 32if [[ ${BUILD_TYPE} = live ]]; then
33 case "${EAPI}" in 33 case ${KDE_SCM} in
34 2 | 2_pre3 | 2_pre2 | 2_pre1) 34 svn) inherit subversion ;;
35 35 git) inherit git-2 ;;
36 qt="["
37 case "${OPENGL_REQUIRED}" in
38 always)
39 qt="${qt}opengl,"
40 ;;
41 optional)
42 qt="${qt}opengl?,"
43 ;;
44 esac
45 qt="${qt}accessibility,dbus,gif,jpeg,png,qt3support,ssl,zlib]"
46 qtcore="[qt3support,ssl]"
47 qtgui="[accessibility,dbus]"
48 qt3support="[accessibility]"
49 ;;
50 esac 36 esac
37fi
51 38
52 # split qt 39# @ECLASS-VARIABLE: CMAKE_REQUIRED
53 qtdepend=" 40# @DESCRIPTION:
54 !x11-libs/qt-phonon 41# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
55 x11-libs/qt-core:4${qtcore} 42# Please note that if it's set to 'never' you need to explicitly override following phases:
56 x11-libs/qt-gui:4${qtgui} 43# src_configure, src_compile, src_test and src_install.
57 x11-libs/qt-qt3support:4${qt3support} 44# Defaults to 'always'.
58 x11-libs/qt-script:4 45: ${CMAKE_REQUIRED:=always}
59 x11-libs/qt-svg:4 46if [[ ${CMAKE_REQUIRED} = always ]]; then
60 x11-libs/qt-test:4" 47 buildsystem_eclass="cmake-utils"
61 qtopengldepend="x11-libs/qt-opengl:4" 48 export_fns="src_configure src_compile src_test src_install"
49fi
62 50
63 # allow monolithic qt for PV < 4.1 51# @ECLASS-VARIABLE: KDE_MINIMAL
52# @DESCRIPTION:
53# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
54# version for apps to work. Currently defaults to 4.4
55# One may override this variable to raise version requirements.
56# Note that it is fixed to ${PV} for kde-base packages.
57KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
58
59# Set slot for KDEBASE known packages
60case ${KDEBASE} in
61 kde-base)
62 SLOT=4
63 KDE_MINIMAL="${PV}"
64 ;;
65 koffice)
66 SLOT="2"
67 ;;
68 kdevelop)
69 if [[ ${BUILD_TYPE} = live ]]; then
70 # @ECLASS-VARIABLE: KDEVELOP_VERSION
71 # @DESCRIPTION:
72 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
73 # Applies to KDEBASE=kdevelop only.
74 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}"
75 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
76 # @DESCRIPTION:
77 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
78 # Applies to KDEBASE=kdevelop only.
79 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}"
80 else
64 case "${PV}" in 81 case ${PN} in
65 scm|9999*|4.1*|4.0.9*|4.0.8*) : ;; 82 kdevelop|quanta)
83 KDEVELOP_VERSION=${PV}
84 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
85 ;;
86 kdevplatform)
87 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
88 KDEVPLATFORM_VERSION=${PV}
89 ;;
66 *) 90 *)
67 qtdepend="|| ( ( ${qtdepend} ) >=x11-libs/qt-4.3.3:4${qt} )" 91 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
68 qtopengldepend="|| ( ${qtopengldepend} >=x11-libs/qt-4.3.3:4 )" 92 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
93 esac
94 fi
95 SLOT="4"
69 ;; 96 ;;
70 esac 97esac
71 98
72 # opengl dependencies 99inherit ${buildsystem_eclass}
73 case "${OPENGL_REQUIRED}" in
74 always)
75 qtdepend="${qtdepend}
76 ${qtopengldepend}"
77 ;;
78 optional)
79 IUSE="${IUSE} opengl"
80 qtdepend="${qtdepend}
81 opengl? ( ${qtopengldepend} )"
82 ;;
83 *)
84 OPENGL_REQUIRED="never"
85 ;;
86 esac
87 100
88 COMMONDEPEND="${COMMONDEPEND} ${qtdepend}" 101EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
89}
90kde4-base_set_qt_dependencies
91 102
92# Set the cmake dependencies 103unset buildsystem_eclass
93case "${PV}" in 104unset export_fns
94 9999*)
95 CMAKEDEPEND=">=dev-util/cmake-2.6"
96 ;;
97 *)
98 CMAKEDEPEND=">=dev-util/cmake-2.4.7-r1"
99 ;;
100esac
101 105
102# Set the common dependencies 106# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
103DEPEND="${DEPEND} ${COMMONDEPEND} ${CMAKEDEPEND} 107# @DESCRIPTION:
104 dev-util/pkgconfig 108# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'.
105 kde-base/automoc 109# This variable must be set before inheriting any eclasses. Defaults to 'never'.
106 x11-libs/libXt 110DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
107 x11-proto/xf86vidmodeproto"
108RDEPEND="${RDEPEND} ${COMMONDEPEND}"
109 111
110# Add the kdeprefix use flag 112# @ECLASS-VARIABLE: QTHELP_REQUIRED
111case "${EAPI}" in 113# @DESCRIPTION:
112 2 | 2_pre3 | 2_pre2 | 2_pre1) 114# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'.
113 IUSE="${IUSE} kdeprefix" 115# This variable must be set before inheriting any eclasses. Defaults to 'never'.
114 ;; 116QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
115esac
116 117
117# @ECLASS-VARIABLE: OPENGL_REQUIRED 118# @ECLASS-VARIABLE: OPENGL_REQUIRED
118# @DESCRIPTION: 119# @DESCRIPTION:
119# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'. 120# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
120# This variable must be set before inheriting any eclasses. Defaults to 'never'. 121# This variable must be set before inheriting any eclasses. Defaults to 'never'.
121OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}" 122OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
122 123
124# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
125# @DESCRIPTION:
126# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
127# This variable must be set before inheriting any eclasses. Defaults to 'never'.
128MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
129
123# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 130# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
124# @DESCRIPTION: 131# @DESCRIPTION:
125# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 132# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
126# This variable must be set before inheriting any eclasses. Defaults to 'never'. 133# This variable must be set before inheriting any eclasses. Defaults to 'never'.
127CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}" 134CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
128 135
129case "${CPPUNIT_REQUIRED}" in 136# @ECLASS-VARIABLE: KDE_REQUIRED
137# @DESCRIPTION:
138# Is kde required? Possible values are 'always', 'optional' and 'never'.
139# This variable must be set before inheriting any eclasses. Defaults to 'always'
140# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
141# Note that for kde-base packages this variable is fixed to 'always'.
142KDE_REQUIRED="${KDE_REQUIRED:-always}"
143
144# @ECLASS-VARIABLE: KDE_HANDBOOK
145# @DESCRIPTION:
146# Set to enable handbook in application. Possible values are 'always', 'optional'
147# (handbook USE flag) and 'never'.
148# This variable must be set before inheriting any eclasses. Defaults to 'never'.
149# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
150# ensures buildtime and runtime dependencies.
151KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
152
153# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
154# @DESCRIPTION:
155# Set this varible if you want your live package to manage its
156# translations. (Mostly all kde ebuilds does not ship documentation
157# and translations in live ebuilds)
158if [[ ${BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
159 # Kdebase actualy provides the handbooks even for live stuff
160 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
161 KDE_LINGUAS=""
162fi
163
164# Setup packages inheriting this eclass
165case ${KDEBASE} in
166 kde-base)
167 HOMEPAGE="http://www.kde.org/"
168 LICENSE="GPL-2"
169 if [[ $BUILD_TYPE = live ]]; then
170 # Disable tests for live ebuilds
171 RESTRICT+=" test"
172 fi
173
174 # Only add the kdeprefix USE flag for older versions, to help
175 # non-portage package managers handle the upgrade
176 if [[ ${PV} < 4.6.4 && ( ( ${KMNAME} != kdepim && ${PN} != kdepim-runtime ) || ${PV} < 4.6 ) ]]; then
177 IUSE+=" kdeprefix"
178 fi
179
180 # This code is to prevent portage from searching GENTOO_MIRRORS for
181 # packages that will never be mirrored. (As they only will ever be in
182 # the overlay).
183 case ${PV} in
184 *9999* | 4.?.[6-9]?)
185 RESTRICT+=" mirror"
186 ;;
187 esac
188 ;;
189 koffice)
190 HOMEPAGE="http://www.koffice.org/"
191 LICENSE="GPL-2"
192 ;;
193 kdevelop)
194 HOMEPAGE="http://www.kdevelop.org/"
195 LICENSE="GPL-2"
196 ;;
197esac
198
199# @ECLASS-VARIABLE: QT_MINIMAL
200# @DESCRIPTION:
201# Determine version of qt we enforce as minimal for the package.
202if version_is_at_least 4.7.80 "${KDE_MINIMAL}"; then
203 QT_MINIMAL="${QT_MINIMAL:-4.7.4}"
204else
205 QT_MINIMAL="${QT_MINIMAL:-4.7.0}"
206fi
207
208# Declarative dependencies
209qtdeclarativedepend="
210 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
211"
212case ${DECLARATIVE_REQUIRED} in
130 always) 213 always)
131 DEPEND="${DEPEND} dev-util/cppunit" 214 COMMONDEPEND+=" ${qtdeclarativedepend}"
132 ;; 215 ;;
133 optional) 216 optional)
134 IUSE="${IUSE} test" 217 IUSE+=" declarative"
135 DEPEND="${DEPEND} 218 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
136 test? ( dev-util/cppunit )"
137 ;; 219 ;;
138 *) 220 *) ;;
139 CPPUNIT_REQUIRED="never" 221esac
222unset qtdeclarativedepend
223
224# QtHelp dependencies
225qthelpdepend="
226 >=x11-libs/qt-assistant-${QT_MINIMAL}:4
227"
228case ${QTHELP_REQUIRED} in
229 always)
230 COMMONDEPEND+=" ${qthelpdepend}"
140 ;; 231 ;;
232 optional)
233 IUSE+=" qthelp"
234 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
235 ;;
141esac 236esac
237unset qthelpdepend
142 238
143# @ECLASS-VARIABLE: NEED_KDE 239# OpenGL dependencies
240qtopengldepend="
241 >=x11-libs/qt-opengl-${QT_MINIMAL}:4
242"
243case ${OPENGL_REQUIRED} in
244 always)
245 COMMONDEPEND+=" ${qtopengldepend}"
246 ;;
247 optional)
248 IUSE+=" opengl"
249 COMMONDEPEND+=" opengl? ( ${qtopengldepend} )"
250 ;;
251 *) ;;
252esac
253unset qtopengldepend
254
255# MultiMedia dependencies
256qtmultimediadepend="
257 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4
258"
259case ${MULTIMEDIA_REQUIRED} in
260 always)
261 COMMONDEPEND+=" ${qtmultimediadepend}"
262 ;;
263 optional)
264 IUSE+=" multimedia"
265 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
266 ;;
267 *) ;;
268esac
269unset qtmultimediadepend
270
271# CppUnit dependencies
272cppuintdepend="
273 dev-util/cppunit
274"
275case ${CPPUNIT_REQUIRED} in
276 always)
277 DEPEND+=" ${cppuintdepend}"
278 ;;
279 optional)
280 IUSE+=" test"
281 DEPEND+=" test? ( ${cppuintdepend} )"
282 ;;
283 *) ;;
284esac
285unset cppuintdepend
286
287
288# WebKit use dependencies
289case ${KDE_REQUIRED} in
290 always)
291 qtwebkitusedeps="[kde]"
292 ;;
293 optional)
294 qtwebkitusedeps="[kde?]"
295 ;;
296 *) ;;
297esac
298# KDE dependencies
299# Qt accessibility classes are needed in various places, bug 325461
300kdecommondepend="
301 dev-lang/perl
302 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
303 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
304 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
305 >=x11-libs/qt-script-${QT_MINIMAL}:4
306 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
307 >=x11-libs/qt-svg-${QT_MINIMAL}:4
308 >=x11-libs/qt-test-${QT_MINIMAL}:4
309 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
310 !aqua? (
311 x11-libs/libXext
312 x11-libs/libXt
313 x11-libs/libXxf86vm
314 x11-libs/libXcomposite
315 x11-libs/libxkbfile
316 )
317"
318
319if [[ ${PN} != kdelibs ]]; then
320 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
321 if [[ ${KDEBASE} = kdevelop ]]; then
322 if [[ ${PN} != kdevplatform ]]; then
323 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
144# @DESCRIPTION: 324 # @DESCRIPTION:
145# This variable sets the version of KDE4 which will be used by the eclass. 325 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
146# This variable must be set by the ebuild, for all categories except for "kde-base". 326 # Applies to KDEBASE=kdevelop only.
147# For kde-base packages, if it is not set by the ebuild, 327 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
148# it's assumed that the required KDE4 version is the latest, non-live, available. 328 case ${KDEVPLATFORM_REQUIRED} in
149# 329 always)
150# @CODE 330 kdecommondepend+="
151# Acceptable values are: 331 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}
152# - latest - Use latest version in the portage tree 332 "
153# Default for kde-base ebuilds. Banned for ebuilds not part of kde or koffice. 333 ;;
154# - svn - Use svn release (live ebuilds)
155# - :SLOT - Use any version in the SLOT specified in the NEED_KDE value.
156# - VERSION_NUMBER - Use the minimum KDE4 version specified in the NEED_KDE value.
157# - VERSION_NUMBER:SLOT - Use the minimum KDE4 version and the SLOT specified in the NEED_KDE value.
158# - none - Let the ebuild handle SLOT, kde dependencies, KDEDIR, ...
159# @CODE
160#
161# Note: There is no default NEED_KDE for ebuilds not in kde-base or part of
162# koffice, so you must set it explicitly in the ebuild, in all other cases.
163if [[ -z ${NEED_KDE} ]]; then
164 if [[ -n ${KDEBASE} ]]; then
165 NEED_KDE="latest"
166 else
167 die "kde4-base.eclass inherited but NEED_KDE not defined - broken ebuild"
168 fi
169fi
170export NEED_KDE
171
172case ${NEED_KDE} in
173 latest)
174 # Should only be used by 'kde-base'-ebuilds
175 if [[ "${KDEBASE}" == "kde-base" ]]; then
176 case ${PV} in
177 4.1*| 4.0.9* | 4.0.8*)
178 _kdedir="4.1"
179 _pv="-${PV}:4.1" ;;
180 4.0*)
181 _kdedir="4.0"
182 _pv="-${PV}:kde-4" ;;
183 3.9*)
184 _kdedir="3.9"
185 _pv="-${PV}:kde-4" ;;
186 *) 334 *) ;;
187 die "NEED_KDE=latest not supported for PV=${PV}" ;;
188 esac
189 _operator=">="
190 else
191 case ${PV} in
192 4.1 | 4.0.9* | 4.0.8*) _kdedir="4.1" ;;
193 4.0*) _kdedir="4.0" ;;
194 3.9*) _kdedir="3.9" ;;
195 *) die "NEED_KDE=latest not supported for PV=${PV}" ;;
196 esac 335 esac
197 fi 336 fi
198 ;; 337 fi
338fi
199 339
200 # NEED_KDE=":${SLOT}" 340kdedepend="
201 :kde-svn) 341 dev-util/automoc
202 _kdedir="svn" 342 dev-util/pkgconfig
203 _pv="-${NEED_KDE}" 343 !aqua? (
204 export NEED_KDE="svn" 344 >=x11-libs/libXtst-1.1.0
205 ;; 345 x11-proto/xf86vidmodeproto
206 :4.1) 346 )
207 _kdedir="4.1" 347"
208 _pv="${NEED_KDE}"
209 ;;
210 :kde-4)
211 _kdedir="4.0"
212 _pv="${NEED_KDE}"
213 ;;
214 348
215 # NEED_KDE="${PV}:${SLOT}" 349kderdepend=""
216 *:kde-svn)
217 _kdedir="svn"
218 _operator=">="
219 _pv="-${NEED_KDE}"
220 export NEED_KDE="svn"
221 ;;
222 *:4.1)
223 _kdedir="4.1"
224 _operator=">="
225 _pv="-${NEED_KDE}"
226 ;;
227 *:kde-4)
228 _kdedir="4.0"
229 _operator=">="
230 _pv="-${NEED_KDE}"
231 ;;
232 350
233 # NEED_KDE="${PV}" 351# all packages needs oxygen icons for basic iconset
234 scm|svn|9999*) 352if [[ ${PN} != oxygen-icons ]]; then
235 _kdedir="svn" 353 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
236 _operator=">=" 354fi
237 _pv="-${NEED_KDE}:kde-svn"
238 export NEED_KDE="svn"
239 ;;
240 4.1 | 4.0.9* | 4.0.8*)
241 _kdedir="4.1"
242 _operator=">="
243 _pv="-${NEED_KDE}:4.1"
244 ;;
245 4.0* | 4)
246 _kdedir="4.0"
247 _operator=">="
248 _pv="-${NEED_KDE}:kde-4"
249 ;;
250 3.9*)
251 _kdedir="3.9"
252 _operator=">="
253 _pv="-${NEED_KDE}:kde-4"
254 ;;
255 355
256 # The ebuild handles dependencies, KDEDIR, SLOT. 356# add a dependency over kde-l10n if EAPI4 or better is around
357if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then
358 for _lingua in ${KDE_LINGUAS}; do
359 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
360 # but only for selected ones.
361 # this can't be done on one line because if user doesn't use any localisation
362 # then he is probably not interested in kde-l10n at all.
363 kderdepend+="
364 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") )
365 "
366 done
367 unset _lingua
368fi
369
370kdehandbookdepend="
371 app-text/docbook-xml-dtd:4.2
372 app-text/docbook-xsl-stylesheets
373"
374kdehandbookrdepend="
375 $(add_kdebase_dep kdelibs 'handbook')
376"
377case ${KDE_HANDBOOK} in
378 always)
379 kdedepend+=" ${kdehandbookdepend}"
380 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
381 ;;
382 optional)
383 IUSE+=" +handbook"
384 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
385 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
386 ;;
387 *) ;;
388esac
389unset kdehandbookdepend kdehandbookrdepend
390
391case ${KDE_SELINUX_MODULE} in
257 none) 392 none) ;;
258 :
259 ;;
260
261 *) 393 *)
262 die "NEED_KDE=${NEED_KDE} currently not supported." 394 IUSE+=" selinux"
395 kdecommondepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
263 ;; 396 ;;
264esac 397esac
265 398
266if [[ ${NEED_KDE} != none ]]; then 399case ${KDE_REQUIRED} in
400 always)
401 IUSE+=" aqua"
402 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
403 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
404 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
405 ;;
406 optional)
407 IUSE+=" aqua kde"
408 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
409 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
410 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
411 ;;
412 *) ;;
413esac
267 414
268 #Set the SLOT 415unset kdecommondepend kdedepend kderdepend
416
417debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
418debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
419debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
420
421# Accumulate dependencies set by this eclass
422DEPEND+=" ${COMMONDEPEND}"
423RDEPEND+=" ${COMMONDEPEND}"
424unset COMMONDEPEND
425
426# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
427# koffice ebuild, the URI should be set in the ebuild itself
428_calculate_src_uri() {
429 debug-print-function ${FUNCNAME} "$@"
430
431 local _kmname _kmname_pv
432
433 # we calculate URI only for known KDEBASE modules
434 [[ -n ${KDEBASE} ]] || return
435
436 # calculate tarball module name
269 if [[ -n ${KDEBASE} ]]; then 437 if [[ -n ${KMNAME} ]]; then
270 if [[ ${NEED_KDE} = svn ]]; then 438 # fixup kdebase-apps name
271 SLOT="kde-svn" 439 case ${KMNAME} in
440 kdebase-apps)
441 _kmname="kdebase" ;;
442 *)
443 _kmname="${KMNAME}" ;;
444 esac
272 else 445 else
446 _kmname=${PN}
447 fi
448 _kmname_pv="${_kmname}-${PV}"
449 case ${KDEBASE} in
450 kde-base)
273 case ${PV} in 451 case ${PV} in
274 4.1* | 4.0.9* | 4.0.8*) SLOT="4.1" ;; 452 4.[456789].8[05] | 4.[456789].9[0235678])
275 *) SLOT="kde-4" ;; 453 # Unstable KDE SC releases
454 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2"
455 if ! version_is_at_least 4.6.80 ${PV}
456 then
457 # KDEPIM IS SPECIAL
458 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/unstable/kdepim/${PV}/${_kmname_pv}.tar.bz2"
459 fi
460 ;;
461 *)
462 # Stable KDE SC releases
463 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2"
464 if ! version_is_at_least 4.6.80 ${PV}
465 then
466 # KDEPIM IS SPECIAL
467 # TODO: It might not be with KDE 4.7 (see above)
468 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2"
469 fi
470 ;;
276 esac 471 esac
277 fi 472 ;;
278 fi 473 koffice)
279
280 # Block install of other SLOTS unless kdeprefix
281 case "${EAPI}" in 474 case ${PV} in
282 2 | 2_pre3 | 2_pre2 | 2_pre1) 475 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
283 for KDE_SLOT in ${KDE_SLOTS[@]}; do 476 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
284 # block non kdeprefix ${PN} on other slots 477 esac
285 if [[ ${SLOT} != ${KDE_SLOT} ]]; then 478 ;;
286 DEPEND="${DEPEND} 479 kdevelop)
287 !kdeprefix? ( !kde-base/${PN}:${KDE_SLOT}[-kdeprefix] )" 480 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2"
288 RDEPEND="${RDEPEND}
289 !kdeprefix? ( !kde-base/${PN}:${KDE_SLOT}[-kdeprefix] )"
290 fi
291 done
292 ;; 481 ;;
293 esac 482 esac
483}
294 484
295 # We only need to add the dependencies if ${PN} is not "kdelibs" or "kdepimlibs" 485_calculate_live_repo() {
296 if [[ ${PN} != "kdelibs" ]]; then 486 debug-print-function ${FUNCNAME} "$@"
487
488 SRC_URI=""
489 case ${KDE_SCM} in
490 svn)
491 # Determine branch URL based on live type
492 local branch_prefix
297 case "${EAPI}" in 493 case ${PV} in
298 2 | 2_pre3 | 2_pre2 | 2_pre1) 494 9999*)
299 DEPEND="${DEPEND} ${_operator}kde-base/kdelibs${_pv}[kdeprefix=]" 495 # trunk
300 RDEPEND="${RDEPEND} ${_operator}kde-base/kdelibs${_pv}[kdeprefix=]" 496 branch_prefix="trunk/KDE"
497 ;;
498 *)
499 # branch
500 branch_prefix="branches/KDE/$(get_kde_version)"
501 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
502 # @DESCRIPTION
503 # Suffix appended to ESVN_PROJECT depending on fetched branch.
504 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
505 ESVN_PROJECT_SUFFIX="-${PV}"
506 ;;
507 esac
508 # @ECLASS-VARIABLE: ESVN_MIRROR
509 # @DESCRIPTION:
510 # This variable allows easy overriding of default kde mirror service
511 # (anonsvn) with anything else you might want to use.
512 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
513 # Split ebuild, or extragear stuff
514 if [[ -n ${KMNAME} ]]; then
515 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
516 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
517 KMMODULE="${PN}"
518 fi
519 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
520 case ${KMNAME} in
521 kdebase-*)
522 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
523 ;;
524 kdelibs-*)
525 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
526 ;;
527 kdereview*)
528 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
529 ;;
530 kdesupport)
531 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
532 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
533 ;;
534 kde*)
535 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
536 ;;
537 extragear*|playground*)
538 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
539 # build packages from same svn location.
540 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
541 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
542 ;;
543 koffice)
544 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
545 ;;
546 *)
547 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
548 ;;
549 esac
550 else
551 # kdelibs, kdepimlibs
552 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
553 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
554 fi
555 # @ECLASS-VARIABLE: ESVN_UP_FREQ
556 # @DESCRIPTION:
557 # This variable is used for specifying the timeout between svn synces
558 # for kde-base and koffice modules. Does not affect misc apps.
559 # Default value is 1 hour.
560 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
561 ;;
562 git)
563 local _kmname
564 # @ECLASS-VARIABLE: EGIT_MIRROR
565 # @DESCRIPTION:
566 # This variable allows easy overriding of default kde mirror service
567 # (anongit) with anything else you might want to use.
568 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
569
570 # @ECLASS-VARIABLE: EGIT_REPONAME
571 # @DESCRIPTION:
572 # This variable allows overriding of default repository
573 # name. Specify only if this differ from PN and KMNAME.
574 if [[ -n ${EGIT_REPONAME} ]]; then
575 # the repository and kmname different
576 _kmname=${EGIT_REPONAME}
577 elif [[ -n ${KMNAME} ]]; then
578 _kmname=${KMNAME}
579 else
580 _kmname=${PN}
581 fi
582
583 # default branching
584 [[ ${PV} != 9999* && ${KDEBASE} == kde-base ]] && \
585 EGIT_BRANCH="KDE/$(get_kde_version)"
586
587 # default repo uri
588 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}"
589
590 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
591 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
592 ;;
593 esac
594}
595
596case ${BUILD_TYPE} in
597 live) _calculate_live_repo ;;
598 *) _calculate_src_uri ;;
599esac
600
601debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
602
603# @ECLASS-VARIABLE: PREFIX
604# @DESCRIPTION:
605# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
606# kde-base packages go into KDE4 installation directory (/usr).
607# No matter the PREFIX, package will be built against KDE installed in /usr.
608
609# @FUNCTION: kde4-base_pkg_setup
610# @DESCRIPTION:
611# Do some basic settings
612kde4-base_pkg_setup() {
613 debug-print-function ${FUNCNAME} "$@"
614
615 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
616 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
617 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
618 fi
619
620 if use_if_iuse kdeprefix; then
621 eerror "Sorry, kdeprefix support has been removed."
622 eerror "Please remove kdeprefix from your USE variable."
623 die "kdeprefix support has been removed"
624 fi
625
626 if [[ ${CATEGORY}/${PN} != kde-base/kdelibs && ${CATEGORY}/${PN} != kde-base/kde-env ]] && \
627 { [[ ${KDE_REQUIRED} == always ]] || { [[ ${KDE_REQUIRED} == optional ]] && use kde; }; } && \
628 has_version kde-base/kdelibs[kdeprefix]; then
629 eerror "Sorry, kdeprefix support has been removed."
630 eerror "Please rebuild kdelibs without kdeprefix support."
631 die "kdeprefix support has been removed"
632 fi
633
634 # Don't set KDEHOME during compilation, it will cause access violations
635 unset KDEHOME
636
637 # Check if gcc compiler is fresh enough.
638 # In theory should be in pkg_pretend but we check it only for kdelibs there
639 # and for others we do just quick scan in pkg_setup because pkg_pretend
640 # executions consume quite some time.
641 # We can only do this for EAPI 4 or later because the MERGE_TYPE variable
642 # is otherwise undefined.
643 if [[ ${EAPI:-0} != 3 ]]; then
644 if [[ ${MERGE_TYPE} != binary ]]; then
645 [[ $(gcc-major-version) -lt 4 ]] || \
646 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \
647 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)."
648 fi
649 fi
650
651 KDEDIR=/usr
652 : ${PREFIX:=/usr}
653 EKDEDIR=${EPREFIX}/usr
654
655 # Point to correct QT plugins path
656 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
657
658 # Fix XDG collision with sandbox
659 export XDG_CONFIG_HOME="${T}"
660}
661
662# @FUNCTION: kde4-base_src_unpack
663# @DESCRIPTION:
664# This function unpacks the source tarballs for KDE4 applications.
665kde4-base_src_unpack() {
666 debug-print-function ${FUNCNAME} "$@"
667
668 if [[ ${BUILD_TYPE} = live ]]; then
669 case ${KDE_SCM} in
670 svn)
671 migrate_store_dir
672 subversion_src_unpack
301 ;; 673 ;;
302 *) 674 git)
303 DEPEND="${DEPEND} ${_operator}kde-base/kdelibs${_pv}" 675 git-2_src_unpack
304 RDEPEND="${RDEPEND} ${_operator}kde-base/kdelibs${_pv}"
305 ;; 676 ;;
306 esac 677 esac
307 if [[ ${PN} != "kdepimlibs" ]]; then
308 case "${EAPI}" in
309 2 | 2_pre3 | 2_pre2 | 2_pre1)
310 DEPEND="${DEPEND} ${_operator}kde-base/kdepimlibs${_pv}[kdeprefix=]"
311 RDEPEND="${RDEPEND} ${_operator}kde-base/kdepimlibs${_pv}[kdeprefix=]"
312 ;;
313 *)
314 DEPEND="${DEPEND} ${_operator}kde-base/kdepimlibs${_pv}"
315 RDEPEND="${RDEPEND} ${_operator}kde-base/kdepimlibs${_pv}"
316 esac
317 fi
318 fi
319
320 unset _operator _pv
321fi
322
323# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
324# koffice ebuild, the URI should be set in the ebuild itself
325if [[ -n ${KDEBASE} ]]; then
326 if [[ -n ${KMNAME} ]]; then
327 _kmname=${KMNAME}
328 else 678 else
329 _kmname=${PN} 679 unpack ${A}
330 fi
331 _kmname_pv="${_kmname}-${PV}"
332 if [[ ${NEED_KDE} != "svn" ]]; then
333 case ${KDEBASE} in
334 kde-base)
335 case ${PV} in
336 4.0.9* | 4.0.8*)
337 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
338 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2";;
339 esac
340 ;;
341 koffice)
342 SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2"
343 ;;
344 esac
345 fi
346 unset _kmname _kmname_pv
347fi
348
349debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
350
351# @ECLASS-VARIABLE: PREFIX
352# @DESCRIPTION:
353# Set the installation PREFIX. All kde-base ebuilds go into the KDE4 installation directory.
354# Applications installed by the other ebuilds go into /usr/ by default, this value
355# can be superseded by defining PREFIX before inheriting kde4-base.
356# This value is set on pkg_setup
357PREFIX=""
358
359debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SLOT ${SLOT} - NEED_KDE ${NEED_KDE}"
360
361# @FUNCTION: kde4-base_pkg_setup
362# @DESCRIPTION:
363# Adds flags needed by all of KDE 4 to $QT4_BUILT_WITH_USE_CHECK. Uses
364# kde4-functions_check_use from kde4-functions.eclass to print appropriate
365# errors and die if any required flags listed in $QT4_BUILT_WITH_USE_CHECK or
366# $KDE4_BUILT_WITH_USE_CHECK are missing.
367kde4-base_pkg_setup() {
368 debug-print-function $FUNCNAME "$@"
369
370 # Don't set KDEHOME during compile, it will cause access violations
371 unset KDEHOME
372
373 if [[ ${NEED_KDE} != none ]]; then
374
375 # Set PREFIX
376 case "${EAPI}" in
377 2 | 2_pre3 | 2_pre2 | 2_pre1)
378 if use kdeprefix; then
379 KDEDIR="/usr/kde/${_kdedir}"
380 KDEDIRS="/usr:/usr/local:${KDEDIR}"
381 else
382 KDEDIR="/usr"
383 KDEDIRS="/usr:/usr/local"
384 fi
385 ;;
386 *)
387 KDEDIR="/usr"
388 KDEDIRS="/usr:/usr/local"
389 ;;
390 esac
391 fi
392
393 # Set the prefix based on KDEDIR
394 # Make it a consequence of kdeprefix
395 PREFIX=${KDEDIR}
396
397 unset _kdedir
398
399 case "${EAPI}" in
400 2 | 2_pre3 | 2_pre2 | 2_pre1)
401 [[ -n ${QT4_BUILT_WITH_USE_CHECK} || -n ${KDE4_BUILT_WITH_USE_CHECK[@]} ]] && \
402 die "built_with_use illegal in this EAPI!"
403 ;;
404 *)
405 # Make KDE4_BUILT_WITH_USE_CHECK an array if it isn't already
406 local line kde4_built_with_use_check=()
407 if [[ -n ${KDE4_BUILT_WITH_USE_CHECK[@]} && $(declare -p KDE4_BUILT_WITH_USE_CHECK) != 'declare -a '* ]]; then
408 while read line; do
409 [[ -z ${line} ]] && continue
410 kde4_built_with_use_check+=("${line}")
411 done <<< "${KDE4_BUILT_WITH_USE_CHECK}"
412 KDE4_BUILT_WITH_USE_CHECK=("${kde4_built_with_use_check[@]}")
413 fi 680 fi
414
415 # KDE4 applications require qt4 compiled with USE="accessibility dbus gif jpeg png qt3support ssl zlib".
416 if has_version '<x11-libs/qt-4.4_alpha:4'; then
417 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} accessibility dbus gif jpeg png qt3support ssl zlib"
418 else
419 KDE4_BUILT_WITH_USE_CHECK=("${KDE4_BUILT_WITH_USE_CHECK[@]}"
420 "x11-libs/qt-core qt3support ssl"
421 "x11-libs/qt-gui accessibility dbus"
422 "x11-libs/qt-qt3support accessibility")
423 fi
424
425 if has opengl ${IUSE//+} && use opengl || [[ ${OPENGL_REQUIRED} == always ]]; then
426 if has_version '<x11-libs/qt-4.4.0_alpha:4'; then
427 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} opengl"
428 fi
429 fi
430 kde4-functions_check_use
431 ;;
432 esac
433} 681}
434 682
435# @FUNCTION: kde4-base_apply_patches
436# @DESCRIPTION:
437# This function applies patches.
438#
439# If the directory ${WORKDIR}/patches/ exists, we apply all patches in that
440# directory, provided they follow this format:
441# @CODE
442# - Monolithic ebuilds, (from kde-base)
443# - $CATEGORY=kde-base:
444# Apply ${CHILD_EBUILD_NAME}-${SLOT}-*{diff,patch}
445# - $CATEGORY=!kde-base:
446# Apply ${CHILD_EBUILD_NAME}-${PV}-*{diff,patch}
447# - Split ebuilds:
448# - $CATEGORY=kde-base:
449# Apply ${PN}-${SLOT}-*{diff,patch}
450# - $CATEGORY!=kde-base:
451# Apply ${PN}-${PV}-*{diff,patch}
452# @CODE
453#
454# If ${PATCHES} is non-zero all patches in it get applied. If there is more
455# than one patch please make ${PATCHES} an array for proper quoting.
456kde4-base_apply_patches() {
457 local _patchdir _packages _p _f
458 _patchdir="${WORKDIR}/patches/"
459 if [[ -d "${_patchdir}" ]]; then
460 if is-parent-package ${CATEGORY}/${PN} ; then
461 _packages="$(get-child-packages ${CATEGORY}/${PN})"
462 _packages="${_packages//${CATEGORY}\//} ${PN}"
463 else
464 _packages="${PN}"
465 fi
466 if [[ $(declare -p PATCHES) != 'declare -a '* ]]; then
467 die "PATCHES needs to be an array!"
468 fi
469 for _p in ${_packages}; do
470 for _f in "${_patchdir}"/${_p}-${PV}-*{diff,patch}; do
471 [[ -e ${_f} ]] && PATCHES+=("${_f}")
472 done
473 if [[ -n "${KDEBASE}" ]]; then
474 for _f in "${_patchdir}"/${_p}-${SLOT}-*{diff,patch}; do
475 [[ -e ${_f} ]] && PATCHES+=("${_f}")
476 done
477 fi
478 done
479 fi
480 [[ -n ${PATCHES[@]} ]] && base_src_unpack autopatch
481}
482
483# @FUNCTION: kde4-base_src_unpack 683# @FUNCTION: kde4-base_src_prepare
484# @DESCRIPTION: 684# @DESCRIPTION:
485# This function unpacks the source tarballs for KDE4 applications. 685# General pre-configure and pre-compile function for KDE4 applications.
486#
487# If no argument is passed to this function, then standard src_unpack is
488# executed. Otherwise options are passed to base_src_unpack.
489#
490# In addition it calls kde4-base_apply_patches when no arguments are passed to
491# this function.
492#
493# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and 686# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and
687# enable_selected_linguas() and enable_selected_doc_linguas()
494# enable_selected_linguas() in kde4-functions.eclass(5) for further details. 688# in kde4-functions.eclass(5) for further details.
495kde4-base_src_unpack() { 689kde4-base_src_prepare() {
496 debug-print-function $FUNCNAME "$@" 690 debug-print-function ${FUNCNAME} "$@"
497 691
498 [[ -z "${KDE_S}" ]] && KDE_S="${S}" 692 # enable handbook and linguas only when not using live ebuild
499
500 if [[ -z $* ]]; then
501 # Unpack first and deal with KDE patches after examing possible patch sets.
502 # To be picked up, patches need to conform to the guidelines stated before.
503 # Monolithic ebuilds will use the split ebuild patches.
504 [[ -d "${KDE_S}" ]] || unpack ${A}
505 base_src_unpack $*
506 else
507 # Call base_src_unpack, which unpacks and patches
508 # step by step transparently as defined in the ebuild.
509 base_src_unpack $*
510 fi
511
512 # Updated cmake dir
513 if [[ -d "${WORKDIR}/cmake" ]] && [[ -d "${KDE_S}/cmake" ]]; then
514 ebegin "Updating cmake/ directory..."
515 rm -rf "${KDE_S}/cmake" || die "Unable to remove old cmake/ directory"
516 ln -s "${WORKDIR}/cmake" "${KDE_S}/cmake" || die "Unable to symlink the new cmake/ directory"
517 eend 0
518 fi
519 693
520 # Only enable selected languages, used for KDE extragear apps. 694 # Only enable selected languages, used for KDE extragear apps.
521 if [[ -n ${KDE_LINGUAS} ]]; then 695 if [[ -n ${KDE_LINGUAS} ]]; then
522 enable_selected_linguas 696 enable_selected_linguas
523 fi 697 fi
698
699 # Enable/disable handbooks for kde4-base packages
700 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
701 # kdelibs inherits kde4-base but handle installing the handbook itself
702 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
703 if [[ ${KDEBASE} == kde-base ]]; then
704 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
705 # documentation in kde4-functions
706 : ${KDE_DOC_DIRS:=doc}
707 local dir
708 for dir in ${KDE_DOC_DIRS}; do
709 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
710 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
711 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
712 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
713 -i CMakeLists.txt || die "failed to comment out handbook"
714 done
715 fi
716 else
717 enable_selected_doc_linguas
718 fi
719 fi
720
721 # SCM bootstrap
722 if [[ ${BUILD_TYPE} = live ]]; then
723 case ${KDE_SCM} in
724 svn) subversion_src_prepare ;;
725 esac
726 fi
727
728 # Apply patches
729 base_src_prepare
730
731 # Save library dependencies
732 if [[ -n ${KMSAVELIBS} ]] ; then
733 save_library_dependencies
734 fi
735
736 # Inject library dependencies
737 if [[ -n ${KMLOADLIBS} ]] ; then
738 load_library_dependencies
739 fi
740
741 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/...
742 if [[ -z ${KDEBASE} ]]; then
743 find "${S}" -name "*.docbook" \
744 -exec sed -i -r \
745 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
746 || die 'failed to fix DocBook variant version'
747 fi
748}
749
750# @FUNCTION: kde4-base_src_configure
751# @DESCRIPTION:
752# Function for configuring the build of KDE4 applications.
753kde4-base_src_configure() {
754 debug-print-function ${FUNCNAME} "$@"
755
756 # Build tests in src_test only, where we override this value
757 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
758
759 if use_if_iuse debug; then
760 # Set "real" debug mode
761 CMAKE_BUILD_TYPE="Debugfull"
762 else
763 # Handle common release builds
764 append-cppflags -DQT_NO_DEBUG
765 fi
766
767 # Set distribution name
768 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
769
770 # Here we set the install prefix
771 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
772
773 # Use colors
774 QTEST_COLORED=1
775
776 # Shadow existing installations
777 unset KDEDIRS
778
779 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
780 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
781 #kde-config -path data unavailable when cross-compiling
782 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
783
784 # sysconf needs to be /etc, not /usr/etc
785 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
786
787 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
788 mycmakeargs=(${mycmakeargs})
789 fi
790
791 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
792
793 cmake-utils_src_configure
524} 794}
525 795
526# @FUNCTION: kde4-base_src_compile 796# @FUNCTION: kde4-base_src_compile
527# @DESCRIPTION: 797# @DESCRIPTION:
528# General function for compiling KDE4 applications. 798# General function for compiling KDE4 applications.
529kde4-base_src_compile() { 799kde4-base_src_compile() {
530 debug-print-function ${FUNCNAME} "$@" 800 debug-print-function ${FUNCNAME} "$@"
531 case "${EAPI}" in
532 2)
533 ;;
534 *)
535 kde4-base_src_configure
536 ;;
537 esac
538 if [[ -d ${WORKDIR}/${PN}_build ]]; then
539 pushd "${WORKDIR}"/${PN}_build > /dev/null
540 fi
541 [ -e [Mm]akefile ] && kde4-base_src_make
542}
543 801
544# @FUNCTION: kde4-base_src_configure
545# @DESCRIPTION:
546# Function for configuring the build of KDE4 applications.
547kde4-base_src_configure() {
548 debug-print-function ${FUNCNAME} "$@"
549
550 # Final flag handling
551 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
552 echo "Activating enable-final flag"
553 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_FINAL=ON"
554 fi
555
556 # Enable generation of HTML handbook
557 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then
558 echo "Enabling building of HTML handbook"
559 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_HTMLHANDBOOK=ON"
560 fi
561
562 # Build tests in src_test only, where we override this value
563 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=OFF"
564
565 # Set distribution name
566 [[ ${PN} == "kdelibs" ]] && mycmakeargs="${mycmakeargs} -DKDE_DISTRIBUTION_TEXT=Gentoo"
567
568 # runpath linking
569 mycmakeargs="${mycmakeargs} -DKDE4_USE_ALWAYS_FULL_RPATH=ON"
570
571 # Here we set the install prefix
572 mycmakeargs="${mycmakeargs} -DCMAKE_INSTALL_PREFIX=${PREFIX}"
573
574 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc
575 [[ "${PREFIX}" == "/usr" ]] && mycmakeargs="${mycmakeargs} -DSYSCONF_INSTALL_DIR=/etc"
576
577 # Set environment
578 QTEST_COLORED=1
579 QT_PLUGIN_PATH=${KDEDIR}/$(get_libdir)/kde4/plugins/
580
581 # hardcode path to *.cmake KDE files
582 PKG_CONFIG_PATH="${PKG_CONFIG_PATH:+${PKG_CONFIG_PATH}:}${KDEDIR}/$(get_libdir)/pkgconfig"
583
584 [ -e CMakeLists.txt ] && cmake-utils_src_configureout
585}
586
587# @FUNCTION: kde4-base_src_make
588# @DESCRIPTION:
589# Function for building KDE4 applications.
590# Options are passed to cmake-utils_src_make.
591kde4-base_src_make() {
592 debug-print-function ${FUNCNAME} "$@"
593
594 cmake-utils_src_make "$@" 802 cmake-utils_src_compile "$@"
595} 803}
596 804
597# @FUNCTION: kde4-base_src_test 805# @FUNCTION: kde4-base_src_test
598# @DESCRIPTION: 806# @DESCRIPTION:
599# Function for testing KDE4 applications. 807# Function for testing KDE4 applications.
600kde4-base_src_test() { 808kde4-base_src_test() {
601 debug-print-function ${FUNCNAME} "$@" 809 debug-print-function ${FUNCNAME} "$@"
602 810
603 # Override this value, set in kde4-base_src_configure() 811 # Override this value, set in kde4-base_src_configure()
604 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=ON" 812 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
605 cmake-utils_src_compile 813 cmake-utils_src_configure
814 kde4-base_src_compile
606 815
816 # When run as normal user during ebuild development with the ebuild command, the
817 # kde tests tend to access the session DBUS. This however is not possible in a real
818 # emerge or on the tinderbox.
819 # > make sure it does not happen, so bad tests can be recognized and disabled
820 unset DBUS_SESSION_BUS_ADDRESS
821
822 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
823 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
824 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
825 # surprise- we are already INSIDE virtualmake!!!
826 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
827 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
828 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
829 debug-print " kde4-base.eclass docs for details... Applying workaround."
830 cmake-utils_src_test
831 else
832 VIRTUALX_COMMAND="cmake-utils_src_test" virtualmake
833 fi
834 else
607 cmake-utils_src_test 835 cmake-utils_src_test
836 fi
608} 837}
609 838
610# @FUNCTION: kde4-base_src_install 839# @FUNCTION: kde4-base_src_install
611# @DESCRIPTION: 840# @DESCRIPTION:
612# Function for installing KDE4 applications. 841# Function for installing KDE4 applications.
613kde4-base_src_install() { 842kde4-base_src_install() {
614 debug-print-function ${FUNCNAME} "$@" 843 debug-print-function ${FUNCNAME} "$@"
615 844
616 kde4-base_src_make_doc 845 if [[ -n ${KMSAVELIBS} ]] ; then
617 if [[ -d ${WORKDIR}/${PN}_build ]]; then 846 install_library_dependencies
618 pushd "${WORKDIR}"/${PN}_build > /dev/null
619 fi 847 fi
620 [ -e [Mm]akefile ] && cmake-utils_src_install
621}
622 848
623# @FUNCTION: kde4-base_src_make_doc
624# @DESCRIPTION:
625# Function for installing the documentation of KDE4 applications. 849 # Install common documentation of KDE4 applications
626kde4-base_src_make_doc() {
627 debug-print-function ${FUNCNAME} "$@"
628
629 local doc 850 local doc
630 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 851 if ! has kde4-meta ${INHERITED}; then
631 [[ -s $doc ]] && dodoc ${doc} 852 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
632 done 853 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
633
634 if [[ -z ${KMNAME} ]]; then
635 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do
636 if [[ -s $doc ]]; then
637 local doc_complete=${doc}
638 doc="${doc#*/}"
639 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
640 fi
641 done 854 done
855 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
856 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
857 done
642 fi 858 fi
643 859
644 if [[ -n ${KDEBASE} && -d "${D}"/usr/share/doc/${PF} ]]; then 860 cmake-utils_src_install
645 # work around bug #97196 861
646 dodir /usr/share/doc/kde && \ 862 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed,
647 mv "${D}"/usr/share/doc/${PF} "${D}"/usr/share/doc/kde/ || \ 863 # because then khelpcenter can't find the docs
648 die "Failed to move docs to kde/ failed." 864 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
865 docompress -x ${PREFIX}/share/doc/HTML
866}
867
868# @FUNCTION: kde4-base_pkg_preinst
869# @DESCRIPTION:
870# Function storing icon caches
871kde4-base_pkg_preinst() {
872 debug-print-function ${FUNCNAME} "$@"
873
874 gnome2_icon_savelist
875 if [[ ${BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
876 subversion_pkg_preinst
649 fi 877 fi
650} 878}
651 879
652# @FUNCTION: kde4-base_pkg_postinst 880# @FUNCTION: kde4-base_pkg_postinst
653# @DESCRIPTION: 881# @DESCRIPTION:
654# Function to rebuild the KDE System Configuration Cache after an application has been installed. 882# Function to rebuild the KDE System Configuration Cache after an application has been installed.
655kde4-base_pkg_postinst() { 883kde4-base_pkg_postinst() {
884 debug-print-function ${FUNCNAME} "$@"
885
886 gnome2_icon_cache_update
887 fdo-mime_desktop_database_update
888 fdo-mime_mime_database_update
656 buildsycoca 889 buildsycoca
890
891 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
892 if [[ ${BUILD_TYPE} = live ]]; then
893 echo
894 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
895 einfo "Use it at your own risk."
896 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
897 echo
898 fi
899 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
900 if [[ ${KDEBASE} != kde-base ]] && \
901 ! has_version 'kde-base/kdebase-runtime-meta' && \
902 ! has_version 'kde-base/kdebase-startkde'; then
903 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
904 echo
905 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
906 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
907 ewarn "With this setting you are unsupported by KDE team."
908 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
909 fi
910 fi
911 fi
657} 912}
658 913
659# @FUNCTION: kde4-base_pkg_postrm 914# @FUNCTION: kde4-base_pkg_postrm
660# @DESCRIPTION: 915# @DESCRIPTION:
661# Function to rebuild the KDE System Configuration Cache after an application has been removed. 916# Function to rebuild the KDE System Configuration Cache after an application has been removed.
662kde4-base_pkg_postrm() { 917kde4-base_pkg_postrm() {
918 debug-print-function ${FUNCNAME} "$@"
919
920 gnome2_icon_cache_update
921 fdo-mime_desktop_database_update
922 fdo-mime_mime_database_update
663 buildsycoca 923 buildsycoca
664} 924}

Legend:
Removed from v.1.17  
changed lines
  Added in v.1.112

  ViewVC Help
Powered by ViewVC 1.1.20